{% extends 'base.html' %}
{% block body %}
    <form method="post" action="">
        {{ macfind_form.hidden_tag() }}
        <div class="form-group">
            <label for="mac">MAC</label>
            <input class="form-control {% if macfind_form.mac.errors|length > 0 %}is-invalid{% endif %}"
                   id="mac" type="text" name="{{ macfind_form.mac.name }}"
                   value="{% if macfind_form.mac.data %}{{ macfind_form.mac.data }}{% elif 'pre_mac' in request.args %}{{ request.args['pre_mac'] }}{% endif %}" required placeholder="MAC-Adresse in beliebigem Format">
            {% if macfind_form.mac.errors %}
                <div class="invalid-feedback">
                    <ul>
                        {% for e in macfind_form.mac.errors %}
                            <li>{{ e }}</li>
                        {% endfor %}
                    </ul>
                </div>
            {% endif %}
        </div>
        <div class="form-group form-group-inline">
            <label for="vlan">VLAN-ID</label>
            <input class="form-control {% if macfind_form.vlan.errors|length > 0 %}is-invalid{% endif %}"
                   id="vlan" type="number" min="2" max="4096" name="{{ macfind_form.vlan.name }}"
                   value="{% if macfind_form.vlan.data %}{{ macfind_form.vlan.data }}{% elif 'pre_vlan' in request.args %}{{ request.args['pre_vlan'] }}{% endif %}">
            {% if macfind_form.vlan.errors %}
                <div class="invalid-feedback">
                    <ul>
                        {% for e in macfind_form.vlan.errors %}
                            <li>{{ e }}</li>
                        {% endfor %}
                    </ul>
                </div>
            {% endif %}
        </div>
        <button type="submit" class="btn btn-outline-primary"
                title="Auf Switches des KIT-Netzes suchen"><i class="fa fa-search"></i> Suchen
        </button>
    </form>
    {% if jobs|length > 0 %}
        <h2>Suchergebnisse dieser Sitzung</h2>
        <table class="table table-striped">
            <tr>
                <th>Startzeit</th>
                <th>MAC</th>
                <th>VLAN-ID</th>
                <th>Devices</th>
                <th colspan="2">Status</th>
            </tr>
            {% for id,res in jobs.items() %}
                <tr class="job" data-jobid="{{ id }}">
                    <td>{{ res.started|strftime }}</td>
                    <td class="mac" data-mac="{{ res.mac }}"><code>{{ res.mac }}</code> {% if res.vendor %}<br/>({{ res.vendor }}){% endif %}</td>
                    <td class="vlan" data-vlan="{{ res.vlan }}">{{ res.vlan }}</td>
                    <td class="result">
                        {% if not res.finished and not res.failed %}<i>Suche läuft...</i>{% endif %}
                        {% if res.finished %}
                            {% if res.status.result|length == 0 %}
                                <i>Keine Ergebnisse</i>
                            {% else %}
                                <ul>
                                    {% for r in res.status.result if r %}
                                        <li>{{ r.host }},
                                            Port {{ r.port }}<br/>{% if r['nd_p_port'] %}Modul:
                                            <span title="{{ r['nd_p_port'].module.root_module.module_type.name }} ({{ r['nd_p_port'].module.root_module.module_type.type_class.name }})">
                                                {% if not r['nd_p_port'].name == r['nd_p_port'].module.root_module.name %}
                                                    {{ r['nd_p_port'].module.root_module.name }}::{% endif %}{{ r['nd_p_port'].name }}</span>,
                                            Gebäude <a target="_blank"
                                                       href="https://www.kit.edu/campusplan/index.php?id={{ r['nd_p_port'].module.root_module.building.nr }}">
                                                {{ r['nd_p_port'].module.root_module.building.nr }}
                                                ({{ r['nd_p_port'].module.root_module.building.name }})</a>,
                                            Raum <span
                                                    title="{{ r['nd_p_port'].module.root_module.room.name }}">{{ r['nd_p_port'].module.root_module.room.nr }}</span>,
                                            <span
                                                    title="{{ r['nd_p_port'].module.root_module.floor.description }}">{{ r['nd_p_port'].module.root_module.floor.nr }}</span>
                                            {% else %}
                                                <i>Fehler bei der Modulauflösung!</i>
                                            {% endif %}
                                        </li>
                                    {% endfor %}
                                </ul>
                            {% endif %}
                        {% endif %}
                    </td>
                    <td class="status_container">
                        {% if not res.finished and not res.failed %}
                            <span class="status" data-status="running">
                            <i class="fa fa-circle-o-notch fa-spin"></i> {% endif %}
                        {% if res.failed %}<span data-status="failed" class="status text-danger">
                            <i class="fa fa-exclamation-triangle"></i> {% endif %}
                        {% if res.finished %}<span data-status="finished" class="status text-success">
                            <i class="fa fa-check"></i> {% endif %}
                        {% if res.status.status == 'queued' %}
                            <span class="status_text">Wartet auf Ausführung</span>
                        {% elif res.status.status == 'started' %}
                            <span class="status_text">Suche läuft</span>
                        {% elif res.status.status == 'finished' %}
                            <span class="status_text">Abgeschlossen</span>
                        {% elif res.failed %}
                            <span class="status_text">Fehlgeschlagen ({{ res.status.message }})</span>
                        {% else %}
                            {{ res.status.status }}
                        {% endif %}
                        </span>
                    </td>
                    <td class="repeat-action">
                        {% if res.failed or res.finished %}
                            <form class="inline" method="post" action="">
                                {{ macfind_form.hidden_tag() }}
                                <input type="hidden" name="{{ macfind_form.mac.name }}" value="{{ res.mac }}">
                                <input type="hidden" name="{{ macfind_form.vlan.name }}" value="{{ res.vlan }}">
                                <button title="Erneut suchen" type="submit" class="btn btn-outline-primary"><i
                                        class="fa fa-repeat"></i>
                                </button>
                            </form>
                        {% endif %}
                    </td>
                </tr>
            {% endfor %}
        </table>
    {% endif %}
{% endblock body %}
{% block post_script %}
    <script src="/static/js/netsuite.macfinder.js"></script>
{% endblock post_script %}
